#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <byteswap.h>

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;

struct
{
  u32 v1;
  u32 v2;
  u32 v3;
  u32 v4;
  u32 v5;
  u32 v6;
  u32 v7;
  u32 v8;
} Chunk_hdr;

struct
{
  u32 v1;
  u32 v2;
  u32 v3;
  u32 v4;
  u32 v5;
  u32 v6;
} ShrekW_hdr;

#define CHUNK 0x4000

char marker[8];
u8 buf[CHUNK];

// Program entry point
int
main( int argc, char *argv[] )
{
  int           i, j, len, xlen, addr;
  u8           *ibuf, *obuf;
  FILE         *fi, *fo;

  if( ( fi = fopen( "ShrekW.BIN", "rb" ) ) == NULL )
    exit( -1 );
  if( ( fo = fopen( "sagem-cat.bin", "wb" ) ) == NULL )
    exit( -1 );
  strcpy( marker, "ShrekW" );
  addr = 0;
  while ( fread( &Chunk_hdr, 4, 8, fi ) == 8 )
  {
    printf( "%05x %08x %08x %08x %08x %08x %08x %08x %08x\n", addr,
	Chunk_hdr.v1, Chunk_hdr.v2, Chunk_hdr.v3, Chunk_hdr.v4, 
	Chunk_hdr.v5, Chunk_hdr.v6, Chunk_hdr.v7, Chunk_hdr.v8 ); 
     len = fread( buf, 1, CHUNK, fi );
     for( i = 0; i < len - 8; i++ )
     {
       for( j = 0; j < 8; j++ )
       {
	 if( buf[i+j] != marker[j] )
	   break;
       }
       if( j == 8 )
    	  break;
     }
     if( j == 8 )
     {
       memcpy( &ShrekW_hdr, &buf[i+8], 4 * 6 );
       printf( "+++++ %08x %08x %08x %08x %08x %08x\n",
	   ShrekW_hdr.v1, ShrekW_hdr.v2, ShrekW_hdr.v3, ShrekW_hdr.v4,
	   ShrekW_hdr.v5, ShrekW_hdr.v6 );
       len = i + 8 + 4 * 6;
     }
     addr += len + 0x20;
     if( j == 8 )
       fseek( fi, addr, SEEK_SET );
     fwrite( buf, 1, len, fo );
  }
  fclose( fo );
  fclose( fi );
  return 0;
}
